// Ball.h

#pragma once

class Ball
{
    double Bx,By;       // {[݈ʒu
    double Spd;         // {[̑x
    double Vx,Vy;       // {[̈ړxiwAxj
    int HomeX,HomeY;    // z[|WViJnAsb`j
public:
    void Init(int HomeX, int HomeY);
    int getBx(){return static_cast<int>(Bx);}
    int getBy(){return static_cast<int>(By);}
    double getSpd(){return Spd;}
    void Kick(int LocX, int LocY, double Spd);
    bool Move();

};

void Ball::Init(int hx, int hy){
    Bx = HomeX = hx;
    By = HomeY = hy;
    Vx = Vy = 0.0;
    Spd = 0.0;
}

// {[RiڕWn_ɌRo߂j
void Ball::Kick(int LocX, int LocY, double Spd)
{
    double Yaw = atan2(LocY - By, LocX - Bx);
    this->Spd = Spd;
    Vx = cos(Yaw);
    Vy = sin(Yaw);
}

bool Ball::Move()
{
    Bx += Vx*Spd;
    By += Vy*Spd;

    Spd *= 0.98;     // nʂƂ̖CɂA]Xs[h
    if(Spd < 0.001) { Spd = 0.0; Vx = Vy = 0.0;}

    // ǂ̔˂ƃS[
    if(By<0.0){Vy=-Vy;By=0.0;}
    if(By>300.0){Vy=-Vy;By=300.0;}

    if((Bx<0.0)||(Bx>600.0)){
        Vx=-Vx;
        if(Bx<300.0) Bx=0.0;
        else Bx=600.0;
        if((By>=100.0)&&(By<=200.0)){
            return true;
        }
    }
    return false;
}